/***
 * Excerpted from "Ultimate Android Power Tips",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material, 
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/mrand for more book information.
***/
package com.mikeriley.talkingclock;

import android.app.Activity; //(1)
import android.content.BroadcastReceiver;
import android.os.Bundle;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.speech.tts.TextToSpeech;
import android.speech.tts.TextToSpeech.OnInitListener;
import android.os.CountDownTimer;
import java.text.SimpleDateFormat;
import java.util.Date;

public class MainActivity extends Activity implements OnInitListener { //(2)

  private TextToSpeech tts; //(3)
  public String batlevel;
  public String charging;
  static final int TTS_CHECK_CODE = 0;
	
  private BroadcastReceiver mBatInfoReceiver = new BroadcastReceiver(){ //(4)
    @Override
    public void onReceive(Context c, Intent i) {
      int level = i.getIntExtra("level", 0);
      batlevel = " at "+Integer.toString(level)+"%";

    IntentFilter ifilter = new IntentFilter(Intent.ACTION_BATTERY_CHANGED); //(5)
    Intent batteryStatus = c.registerReceiver(null, ifilter);
    int status = batteryStatus.getIntExtra(BatteryManager.EXTRA_STATUS, -1);
    boolean isCharging = status == BatteryManager.BATTERY_STATUS_CHARGING ||
                         status == BatteryManager.BATTERY_STATUS_FULL;    
    if (isCharging) {
    batlevel = batlevel + " and charging."; 
      }      
    }
  };
	
	
  @Override
  public void onCreate(Bundle savedInstanceState) { //(6)
    super.onCreate(savedInstanceState);
    registerReceiver(mBatInfoReceiver, 
      new IntentFilter(Intent.ACTION_BATTERY_CHANGED));
    tts = new TextToSpeech(this, this);
  }
	
  @Override
  public void onInit(int status) { //(7)
    if (status == TextToSpeech.SUCCESS)
    {
      Date todaysDate = new java.util.Date();
      SimpleDateFormat hour = new SimpleDateFormat("h");
      SimpleDateFormat minute = new SimpleDateFormat("m");
      SimpleDateFormat ampm = new SimpleDateFormat("a");
      String sHour = hour.format(todaysDate);
      String sMinute = minute.format(todaysDate);
      String sAMPM = ampm.format(todaysDate);
      if (sAMPM.equals("AM")) { 
        sAMPM = "A M";
      } else {
	sAMPM = "P M";
      }
      String current_hour = sHour.concat(" ");
      current_hour.replaceAll("00 ", "");
      if (sMinute.contentEquals("0")) {
        sMinute = "o clock";
      } else {
        if (sMinute.matches("\\d")) {
          sMinute = "o ".concat(sMinute);
        }
      }
	        
      String current_time = current_hour.concat(sMinute);
      current_time = current_time.concat(sAMPM);
      String current_status = current_time.concat(batlevel);
      tts.speak(current_status, TextToSpeech.QUEUE_FLUSH, null); //(8)
      new CountDownTimer(3000, 1000) {
      public void onTick(long millisUntilFinished) { //(9)
      }
      public void onFinish() { //(10)
        unregisterReceiver(mBatInfoReceiver);
        tts.shutdown();
        finish();
        }
      }.start();
    }
  }
}